Module javafx.graphics
Package javafx.scene.layout

## Class BorderPane

- java.lang.Object
- - javafx.scene.Node
  - - javafx.scene.Parent
    - - javafx.scene.layout.Region
      - - javafx.scene.layout.Pane
        - - javafx.scene.layout.BorderPane

- All Implemented Interfaces:
    `Styleable`, `EventTarget`

      public class BorderPane
      extends Pane

  BorderPane lays out children in top, left, right, bottom, and center positions.

  The top and bottom children will be resized to their preferred heights and extend the width of the border pane. The left and right children will be resized to their preferred widths and extend the length between the top and bottom nodes. And the center node will be resized to fill the available space in the middle. Any of the positions may be null. Example:

           BorderPane borderPane = new BorderPane();
           ToolBar toolbar = new ToolBar();
           HBox statusbar = new HBox();
           Node appContent = new AppContentNode();
           borderPane.setTop(toolbar);
           borderPane.setCenter(appContent);
           borderPane.setBottom(statusbar);

  Borderpanes may be styled with backgrounds and borders using CSS. See `Region` superclass for details.

  BorderPane honors the minimum, preferred, and maximum sizes of its children. If the child's resizable range prevents it from be resized to fit within its position, it will be aligned relative to the space using a default alignment as follows:

  - top: Pos.TOP_LEFT
  - bottom: Pos.BOTTOM_LEFT
  - left: Pos.TOP_LEFT
  - right: Pos.TOP_RIGHT
  - center: Pos.CENTER
  See "Optional Layout Constraints" on how to customize these alignments.

  BorderPane lays out each child set in the five positions regardless of the child's visible property value; unmanaged children are ignored.

  ### Resizable Range

  BorderPane is commonly used as the root of a `Scene`, in which case its size will track the size of the scene. If the scene or stage size has not been directly set by the application, the scene size will be initialized to the border pane's preferred size. However, if a border pane has a parent other than the scene, that parent will resize the border pane within the border pane's resizable range during layout. By default the border pane computes this range based on its content as outlined in the table below.

  BorderPane Resize Table
  | width | height
  minimum | left/right insets plus width required to display right/left children at their pref widths and top/bottom/center with at least their min widths | top/bottom insets plus height required to display top/bottom children at their pref heights and left/right/center with at least their min heights
  preferred | left/right insets plus width required to display top/right/bottom/left/center children with at least their pref widths | top/bottom insets plus height required to display top/right/bottom/left/center children with at least their pref heights
  maximum | Double.MAX_VALUE | Double.MAX_VALUE

  A border pane's unbounded maximum width and height are an indication to the parent that it may be resized beyond its preferred size to fill whatever space is assigned to it.

  BorderPane provides properties for setting the size range directly. These properties default to the sentinel value Region.USE_COMPUTED_SIZE, however the application may set them to other values as needed:

           borderPane.setPrefSize(500,400);

  Applications may restore the computed values by setting these properties back to Region.USE_COMPUTED_SIZE.

  BorderPane does not clip its content by default, so it is possible that children's bounds may extend outside its own bounds if a child's min size prevents it from being fit within it space.

  #### Optional Layout Constraints

  An application may set constraints on individual children to customize BorderPane's layout. For each constraint, BorderPane provides a static method for setting it on the child.

  BorderPane Constraint Table
  Constraint | Type | Description
  --- | --- | ---
  alignment | javafx.geometry.Pos | The alignment of the child within its area of the border pane.
  margin | javafx.geometry.Insets | Margin space around the outside of the child.

  Example:

           ListView list = new ListView();
           BorderPane.setAlignment(list, Pos.TOP_LEFT);
           BorderPane.setMargin(list, new Insets(12,12,12,12));
           borderPane.setCenter(list);

  Since:
    JavaFX 2.0

- - ### Property Summary

    Properties
    Type | Property | Description
    --- | --- | ---
    `ObjectProperty<Node>` | `bottom` | The node placed on the bottom edge of this border pane.
    `ObjectProperty<Node>` | `center` | The node placed in the center of this border pane.
    `ObjectProperty<Node>` | `left` | The node placed on the left edge of this border pane.
    `ObjectProperty<Node>` | `right` | The node placed on the right edge of this border pane.
    `ObjectProperty<Node>` | `top` | The node placed on the top edge of this border pane.

    - ### Properties inherited from class javafx.scene.layout.Region

      `background, border, cacheShape, centerShape, height, insets, maxHeight, maxWidth, minHeight, minWidth, opaqueInsets, padding, prefHeight, prefWidth, scaleShape, shape, snapToPixel, width`

    - ### Properties inherited from class javafx.scene.Parent

      `needsLayout`

    - ### Properties inherited from class javafx.scene.Node

      `accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

  - ### Field Summary

    - ### Fields inherited from class javafx.scene.layout.Region

      `USE_COMPUTED_SIZE, USE_PREF_SIZE`

    - ### Fields inherited from class javafx.scene.Node

      `BASELINE_OFFSET_SAME_AS_HEIGHT`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BorderPane()` | Creates a BorderPane layout.
    `BorderPane​(Node center)` | Creates an BorderPane layout with the given Node as the center of the BorderPane.
    `BorderPane​(Node center, Node top, Node right, Node bottom, Node left)` | Creates an BorderPane layout with the given Nodes to use for each of the main layout areas of the Border Pane.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `ObjectProperty<Node>` | `bottomProperty()` | The node placed on the bottom edge of this border pane.
    `ObjectProperty<Node>` | `centerProperty()` | The node placed in the center of this border pane.
    `static void` | `clearConstraints​(Node child)` | Removes all border pane constraints from the child node.
    `protected double` | `computeMinHeight​(double width)` | Computes the minimum height of this region.
    `protected double` | `computeMinWidth​(double height)` | Computes the minimum width of this region.
    `protected double` | `computePrefHeight​(double width)` | Computes the preferred height of this region for the given width; Region subclasses should override this method to return an appropriate value based on their content and layout strategy.
    `protected double` | `computePrefWidth​(double height)` | Computes the preferred width of this region for the given height.
    `static Pos` | `getAlignment​(Node child)` | Returns the child's alignment constraint if set.
    `Node` | `getBottom()` | Gets the value of the property bottom.
    `Node` | `getCenter()` | Gets the value of the property center.
    `Orientation` | `getContentBias()` | Returns the orientation of a node's resizing bias for layout purposes.
    `Node` | `getLeft()` | Gets the value of the property left.
    `static Insets` | `getMargin​(Node child)` | Returns the child's margin constraint if set.
    `Node` | `getRight()` | Gets the value of the property right.
    `Node` | `getTop()` | Gets the value of the property top.
    `protected void` | `layoutChildren()` | Invoked during the layout pass to layout the children in this `Parent`.
    `ObjectProperty<Node>` | `leftProperty()` | The node placed on the left edge of this border pane.
    `ObjectProperty<Node>` | `rightProperty()` | The node placed on the right edge of this border pane.
    `static void` | `setAlignment​(Node child, Pos value)` | Sets the alignment for the child when contained by a border pane.
    `void` | `setBottom​(Node value)` | Sets the value of the property bottom.
    `void` | `setCenter​(Node value)` | Sets the value of the property center.
    `void` | `setLeft​(Node value)` | Sets the value of the property left.
    `static void` | `setMargin​(Node child, Insets value)` | Sets the margin for the child when contained by a border pane.
    `void` | `setRight​(Node value)` | Sets the value of the property right.
    `void` | `setTop​(Node value)` | Sets the value of the property top.
    `ObjectProperty<Node>` | `topProperty()` | The node placed on the top edge of this border pane.

    - ### Methods inherited from class javafx.scene.layout.Pane

      `getChildren`

    - ### Methods inherited from class javafx.scene.layout.Region

      `backgroundProperty, borderProperty, cacheShapeProperty, centerShapeProperty, computeMaxHeight, computeMaxWidth, getBackground, getBorder, getClassCssMetaData, getCssMetaData, getHeight, getInsets, getMaxHeight, getMaxWidth, getMinHeight, getMinWidth, getOpaqueInsets, getPadding, getPrefHeight, getPrefWidth, getShape, getUserAgentStylesheet, getWidth, heightProperty, insetsProperty, isCacheShape, isCenterShape, isResizable, isScaleShape, isSnapToPixel, layoutInArea, layoutInArea, layoutInArea, layoutInArea, maxHeight, maxHeightProperty, maxWidth, maxWidthProperty, minHeight, minHeightProperty, minWidth, minWidthProperty, opaqueInsetsProperty, paddingProperty, positionInArea, positionInArea, prefHeight, prefHeightProperty, prefWidth, prefWidthProperty, resize, scaleShapeProperty, setBackground, setBorder, setCacheShape, setCenterShape, setHeight, setMaxHeight, setMaxSize, setMaxWidth, setMinHeight, setMinSize, setMinWidth, setOpaqueInsets, setPadding, setPrefHeight, setPrefSize, setPrefWidth, setScaleShape, setShape, setSnapToPixel, setWidth, shapeProperty, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, snapToPixelProperty, widthProperty`

    - ### Methods inherited from class javafx.scene.Parent

      `getBaselineOffset, getChildrenUnmodifiable, getManagedChildren, getStylesheets, isNeedsLayout, layout, lookup, needsLayoutProperty, queryAccessibleAttribute, requestLayout, requestParentLayout, setNeedsLayout, updateBounds`

    - ### Methods inherited from class javafx.scene.Node

      `accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, executeAccessibleAction, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInitialFocusTraversable, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookupAll, managedProperty, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, pressedProperty, pseudoClassStateChanged, relocate, removeEventFilter, removeEventHandler, requestFocus, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, toString, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javafx.css.Styleable

      `getStyleableNode`

- - ### Property Detail

    - #### center

          public final ObjectProperty<Node> centerProperty

      The node placed in the center of this border pane. If resizable, it will be resized fill the center of the border pane between the top, bottom, left, and right nodes. If the node cannot be resized to fill the center space (it's not resizable or its max size prevents it) then it will be center aligned unless the child's alignment constraint has been set.
      See Also:
        `getCenter()`, `setCenter(Node)`

    - #### top

          public final ObjectProperty<Node> topProperty

      The node placed on the top edge of this border pane. If resizable, it will be resized to its preferred height and it's width will span the width of the border pane. If the node cannot be resized to fill the top space (it's not resizable or its max size prevents it) then it will be aligned top-left within the space unless the child's alignment constraint has been set.
      See Also:
        `getTop()`, `setTop(Node)`

    - #### bottom

          public final ObjectProperty<Node> bottomProperty

      The node placed on the bottom edge of this border pane. If resizable, it will be resized to its preferred height and it's width will span the width of the border pane. If the node cannot be resized to fill the bottom space (it's not resizable or its max size prevents it) then it will be aligned bottom-left within the space unless the child's alignment constraint has been set.
      See Also:
        `getBottom()`, `setBottom(Node)`

    - #### left

          public final ObjectProperty<Node> leftProperty

      The node placed on the left edge of this border pane. If resizable, it will be resized to its preferred width and it's height will span the height of the border pane between the top and bottom nodes. If the node cannot be resized to fill the left space (it's not resizable or its max size prevents it) then it will be aligned top-left within the space unless the child's alignment constraint has been set.
      See Also:
        `getLeft()`, `setLeft(Node)`

    - #### right

          public final ObjectProperty<Node> rightProperty

      The node placed on the right edge of this border pane. If resizable, it will be resized to its preferred width and it's height will span the height of the border pane between the top and bottom nodes. If the node cannot be resized to fill the right space (it's not resizable or its max size prevents it) then it will be aligned top-right within the space unless the child's alignment constraint has been set.
      See Also:
        `getRight()`, `setRight(Node)`

  - ### Constructor Detail

    - #### BorderPane

          public BorderPane()

      Creates a BorderPane layout.

    - #### BorderPane

          public BorderPane​(Node center)

      Creates an BorderPane layout with the given Node as the center of the BorderPane.
      Parameters:
        `center` - The node to set as the center of the BorderPane.
      Since:
        JavaFX 8.0

    - #### BorderPane

          public BorderPane​(Node center,
                            Node top,
                            Node right,
                            Node bottom,
                            Node left)

      Creates an BorderPane layout with the given Nodes to use for each of the main layout areas of the Border Pane. The top, right, bottom, and left nodes are listed in clockwise order.
      Parameters:
        `center` - The node to set as the center of the BorderPane.
        `top` - The node to set as the top of the BorderPane.
        `right` - The node to set as the right of the BorderPane.
        `bottom` - The node to set as the bottom of the BorderPane.
        `left` - The node to set as the left of the BorderPane.
      Since:
        JavaFX 8.0

  - ### Method Detail

    - #### setAlignment

          public static void setAlignment​(Node child,
                                          Pos value)

      Sets the alignment for the child when contained by a border pane. If set, will override the border pane's default alignment for the child's position. Setting the value to null will remove the constraint.
      Parameters:
        `child` - the child node of a border pane
        `value` - the alignment position for the child

    - #### getAlignment

          public static Pos getAlignment​(Node child)

      Returns the child's alignment constraint if set.
      Parameters:
        `child` - the child node of a border pane
      Returns:
        the alignment position for the child or null if no alignment was set

    - #### setMargin

          public static void setMargin​(Node child,
                                       Insets value)

      Sets the margin for the child when contained by a border pane. If set, the border pane will lay it out with the margin space around it. Setting the value to null will remove the constraint.
      Parameters:
        `child` - the child node of a border pane
        `value` - the margin of space around the child

    - #### getMargin

          public static Insets getMargin​(Node child)

      Returns the child's margin constraint if set.
      Parameters:
        `child` - the child node of a border pane
      Returns:
        the margin for the child or null if no margin was set

    - #### clearConstraints

          public static void clearConstraints​(Node child)

      Removes all border pane constraints from the child node.
      Parameters:
        `child` - the child node

    - #### centerProperty

          public final ObjectProperty<Node> centerProperty()

      The node placed in the center of this border pane. If resizable, it will be resized fill the center of the border pane between the top, bottom, left, and right nodes. If the node cannot be resized to fill the center space (it's not resizable or its max size prevents it) then it will be center aligned unless the child's alignment constraint has been set.
      See Also:
        `getCenter()`, `setCenter(Node)`

    - #### setCenter

          public final void setCenter​(Node value)

      Sets the value of the property center.
      Property description:
        The node placed in the center of this border pane. If resizable, it will be resized fill the center of the border pane between the top, bottom, left, and right nodes. If the node cannot be resized to fill the center space (it's not resizable or its max size prevents it) then it will be center aligned unless the child's alignment constraint has been set.

    - #### getCenter

          public final Node getCenter()

      Gets the value of the property center.
      Property description:
        The node placed in the center of this border pane. If resizable, it will be resized fill the center of the border pane between the top, bottom, left, and right nodes. If the node cannot be resized to fill the center space (it's not resizable or its max size prevents it) then it will be center aligned unless the child's alignment constraint has been set.

    - #### topProperty

          public final ObjectProperty<Node> topProperty()

      The node placed on the top edge of this border pane. If resizable, it will be resized to its preferred height and it's width will span the width of the border pane. If the node cannot be resized to fill the top space (it's not resizable or its max size prevents it) then it will be aligned top-left within the space unless the child's alignment constraint has been set.
      See Also:
        `getTop()`, `setTop(Node)`

    - #### setTop

          public final void setTop​(Node value)

      Sets the value of the property top.
      Property description:
        The node placed on the top edge of this border pane. If resizable, it will be resized to its preferred height and it's width will span the width of the border pane. If the node cannot be resized to fill the top space (it's not resizable or its max size prevents it) then it will be aligned top-left within the space unless the child's alignment constraint has been set.

    - #### getTop

          public final Node getTop()

      Gets the value of the property top.
      Property description:
        The node placed on the top edge of this border pane. If resizable, it will be resized to its preferred height and it's width will span the width of the border pane. If the node cannot be resized to fill the top space (it's not resizable or its max size prevents it) then it will be aligned top-left within the space unless the child's alignment constraint has been set.

    - #### bottomProperty

          public final ObjectProperty<Node> bottomProperty()

      The node placed on the bottom edge of this border pane. If resizable, it will be resized to its preferred height and it's width will span the width of the border pane. If the node cannot be resized to fill the bottom space (it's not resizable or its max size prevents it) then it will be aligned bottom-left within the space unless the child's alignment constraint has been set.
      See Also:
        `getBottom()`, `setBottom(Node)`

    - #### setBottom

          public final void setBottom​(Node value)

      Sets the value of the property bottom.
      Property description:
        The node placed on the bottom edge of this border pane. If resizable, it will be resized to its preferred height and it's width will span the width of the border pane. If the node cannot be resized to fill the bottom space (it's not resizable or its max size prevents it) then it will be aligned bottom-left within the space unless the child's alignment constraint has been set.

    - #### getBottom

          public final Node getBottom()

      Gets the value of the property bottom.
      Property description:
        The node placed on the bottom edge of this border pane. If resizable, it will be resized to its preferred height and it's width will span the width of the border pane. If the node cannot be resized to fill the bottom space (it's not resizable or its max size prevents it) then it will be aligned bottom-left within the space unless the child's alignment constraint has been set.

    - #### leftProperty

          public final ObjectProperty<Node> leftProperty()

      The node placed on the left edge of this border pane. If resizable, it will be resized to its preferred width and it's height will span the height of the border pane between the top and bottom nodes. If the node cannot be resized to fill the left space (it's not resizable or its max size prevents it) then it will be aligned top-left within the space unless the child's alignment constraint has been set.
      See Also:
        `getLeft()`, `setLeft(Node)`

    - #### setLeft

          public final void setLeft​(Node value)

      Sets the value of the property left.
      Property description:
        The node placed on the left edge of this border pane. If resizable, it will be resized to its preferred width and it's height will span the height of the border pane between the top and bottom nodes. If the node cannot be resized to fill the left space (it's not resizable or its max size prevents it) then it will be aligned top-left within the space unless the child's alignment constraint has been set.

    - #### getLeft

          public final Node getLeft()

      Gets the value of the property left.
      Property description:
        The node placed on the left edge of this border pane. If resizable, it will be resized to its preferred width and it's height will span the height of the border pane between the top and bottom nodes. If the node cannot be resized to fill the left space (it's not resizable or its max size prevents it) then it will be aligned top-left within the space unless the child's alignment constraint has been set.

    - #### rightProperty

          public final ObjectProperty<Node> rightProperty()

      The node placed on the right edge of this border pane. If resizable, it will be resized to its preferred width and it's height will span the height of the border pane between the top and bottom nodes. If the node cannot be resized to fill the right space (it's not resizable or its max size prevents it) then it will be aligned top-right within the space unless the child's alignment constraint has been set.
      See Also:
        `getRight()`, `setRight(Node)`

    - #### setRight

          public final void setRight​(Node value)

      Sets the value of the property right.
      Property description:
        The node placed on the right edge of this border pane. If resizable, it will be resized to its preferred width and it's height will span the height of the border pane between the top and bottom nodes. If the node cannot be resized to fill the right space (it's not resizable or its max size prevents it) then it will be aligned top-right within the space unless the child's alignment constraint has been set.

    - #### getRight

          public final Node getRight()

      Gets the value of the property right.
      Property description:
        The node placed on the right edge of this border pane. If resizable, it will be resized to its preferred width and it's height will span the height of the border pane between the top and bottom nodes. If the node cannot be resized to fill the right space (it's not resizable or its max size prevents it) then it will be aligned top-right within the space unless the child's alignment constraint has been set.

    - #### getContentBias

          public Orientation getContentBias()

      Description copied from class: `Node`
      Returns the orientation of a node's resizing bias for layout purposes. If the node type has no bias, returns null. If the node is resizable and it's height depends on its width, returns HORIZONTAL, else if its width depends on its height, returns VERTICAL.

      Resizable subclasses should override this method to return an appropriate value.

      Overrides:
        `getContentBias` in class `Node`
      Returns:
        null unless the center, right, bottom, left or top has a content bias.
      See Also:
        `Node.isResizable()`, `Node.minWidth(double)`, `Node.minHeight(double)`, `Node.prefWidth(double)`, `Node.prefHeight(double)`, `Node.maxWidth(double)`, `Node.maxHeight(double)`

    - #### computeMinWidth

          protected double computeMinWidth​(double height)

      Description copied from class: `Region`
      Computes the minimum width of this region. Returns the sum of the left and right insets by default. region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a VERTICAL content bias, then the height parameter can be ignored.
      Overrides:
        `computeMinWidth` in class `Region`
      Parameters:
        `height` - the height that should be used if min width depends on it
      Returns:
        the computed minimum width of this region

    - #### computeMinHeight

          protected double computeMinHeight​(double width)

      Description copied from class: `Region`
      Computes the minimum height of this region. Returns the sum of the top and bottom insets by default. Region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a HORIZONTAL content bias, then the width parameter can be ignored.
      Overrides:
        `computeMinHeight` in class `Region`
      Parameters:
        `width` - the width that should be used if min height depends on it
      Returns:
        the computed minimum height for this region

    - #### computePrefWidth

          protected double computePrefWidth​(double height)

      Description copied from class: `Region`
      Computes the preferred width of this region for the given height. Region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a VERTICAL content bias, then the height parameter can be ignored.
      Overrides:
        `computePrefWidth` in class `Region`
      Parameters:
        `height` - the height that should be used if preferred width depends on it
      Returns:
        the computed preferred width for this region

    - #### computePrefHeight

          protected double computePrefHeight​(double width)

      Description copied from class: `Region`
      Computes the preferred height of this region for the given width; Region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a HORIZONTAL content bias, then the width parameter can be ignored.
      Overrides:
        `computePrefHeight` in class `Region`
      Parameters:
        `width` - the width that should be used if preferred height depends on it
      Returns:
        the computed preferred height for this region

    - #### layoutChildren

          protected void layoutChildren()

      Description copied from class: `Parent`
      Invoked during the layout pass to layout the children in this `Parent`. By default it will only set the size of managed, resizable content to their preferred sizes and does not do any node positioning.

      Subclasses should override this function to layout content as needed.

      Overrides:
        `layoutChildren` in class `Parent`